classification
Title: multiprocessing.Connection endianness issue
Type: behavior Stage: resolved
Components: Library (Lib) Versions: Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: neologix, python-dev, vstinner
Priority: normal Keywords: needs review, patch

Created on 2011-09-16 18:40 by neologix, last changed 2011-09-20 18:27 by neologix. This issue is now closed.

Files
File name Uploaded Description Edit
multiprocessing_conn_endianness.diff neologix, 2011-09-16 18:40 review
Messages (4)
msg144148 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2011-09-16 18:40
Since the rewrite in pure Python of multiprocessing.Connection (issue #11743), multiprocessing.Connection sends and receives the length of the data (used as header) in host byte order.
This will break if the connection's endpoints are on machine with different endianness.
Patch attached (it also removes an unnecessary computation of the length of the data being sent).
msg144236 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2011-09-18 09:56
"Since the rewrite in pure Python of multiprocessing.Connection (issue #11743), multiprocessing.Connection sends and receives the length of the data (used as header) in host byte order."

I don't think so, the C code uses also the host endian. This issue is a feature request.

I don't know if anyone uses multiprocessing on different hosts (because it doesn't work currently).

If you would like to support using multiprocessing on different hosts, it should be documented in multiprocessing doc.
msg144239 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2011-09-18 11:02
> "Since the rewrite in pure Python of multiprocessing.Connection (issue #11743), multiprocessing.Connection sends and receives the length of the data (used as header) in host byte order."
>
> I don't think so, the C code uses also the host endian. This issue is a feature request.
>

No.
http://hg.python.org/cpython/file/5deecc04b7a2/Modules/_multiprocessing/socket_connection.c
In conn_send_string():
"""
     /* The "header" of the message is a 32 bit unsigned number (in
        network order) which specifies the length of the "body".  If
        the message is shorter than about 16kb then it is quicker to
        combine the "header" and the "body" of the message and send
        them at once. */
[...]
         *(UINT32*)message = htonl((UINT32)length);
"""

in conn_recv_string():
"""
     ulength = ntohl(ulength);
"""

> I don't know if anyone uses multiprocessing on different hosts (because it doesn't work currently).
>
> If you would like to support using multiprocessing on different hosts, it should be documented in multiprocessing doc.

It does work, it's even documented ;-)

http://docs.python.org/dev/library/multiprocessing.html#multiprocessing-managers
"""
A manager object returned by Manager() controls a server process which
holds Python objects and allows other processes to manipulate them
using proxies.
[...]
Server process managers are more flexible than using shared memory
objects because they can be made to support arbitrary object types.
Also, a single manager can be shared by processes on different
computers over a network. They are, however, slower than using shared
memory.
"""

Managers use multiprocessing.connection to serialize data and send
them over a socket:
http://hg.python.org/cpython/file/5deecc04b7a2/Lib/multiprocessing/managers.py
"""
#
# Mapping from serializer name to Listener and Client types
#
listener_client = {
     'pickle' : (connection.Listener, connection.Client),
     'xmlrpclib' : (connection.XmlListener, connection.XmlClient)
     }
"""

Yeah, Python's awesome :-)
msg144342 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2011-09-20 17:25
New changeset 9c1c81d24e23 by Charles-François Natali in branch 'default':
Issue #12996: multiprocessing.connection: transmit the header in network byte
http://hg.python.org/cpython/rev/9c1c81d24e23
History
Date User Action Args
2011-09-20 18:27:21neologixsetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2011-09-20 17:25:53python-devsetnosy: + python-dev
messages: + msg144342
2011-09-18 11:02:28neologixsetmessages: + msg144239
2011-09-18 09:56:52vstinnersetmessages: + msg144236
2011-09-16 18:40:54neologixcreate